package provide GEOplot 1.0

# THIS procedure reads in the option file

proc BegDMSP { defNo } {
   global sInfo pgmOPTS env

   if !$pgmOPTS(UCalled) {
      UDFInits
      set pgmOPTS(UCalled) 1
   }

# GET the DMSP Satellite information

   set SaT  $pgmOPTS(DMSPsat)
   set sNum [string range $SaT 6 7]

# DETERMINE which virtuals and sensors need to be read and which units
#    each of the sensors needs to be returned in.

   set oI [OpenInfo $sNum]

# IF there are no plots then we are finished

   if { [lindex $oI 0] == 0 } { return }

# SET the start and stop times

   set pgmOPTS(BegT) [expr ($pgmOPTS(BegHr) * 3600 + \
                            $pgmOPTS(BegMn) * 60 + $pgmOPTS(BegSc)) * 1000]
   set pgmOPTS(EndT) [expr ($pgmOPTS(EndHr) * 3600 + \
                            $pgmOPTS(EndMn) * 60 + $pgmOPTS(EndSc)) * 1000]


# LOOP over the experiments and open those which are returning data

   set ViD [list ""  OA SI SE SSIES]

   for { set I 1 } { $I <= 4 } { incr I } {
      set InFo [lindex $oI $I]
      set iD   [lindex $ViD $I]

      set pgmOPTS(K.$iD) ""
      set pgmOPTS(S.$iD) ""
      set pgmOPTS(U.$iD) ""
      set pgmOPTS(I.$iD) ""
      set pgmOPTS(eV.$iD) ""
      set LeN [llength $InFo]
      if { $LeN < 4 } { continue }

      set Exp  [lindex $InFo 0]
      set Inst [lindex $InFo 1]
      set Vir  [lindex $InFo 2]

      set kO [GetDataKey DMSP $SaT $Exp $Inst $Vir]
      set pgmOPTS(K.$iD) $kO
      FileOpen $kO $defNo $pgmOPTS(BegYr) $pgmOPTS(BegDy) $pgmOPTS(BegHr) \
            $pgmOPTS(BegMn) $pgmOPTS(BegSc) $pgmOPTS(EndYr) $pgmOPTS(EndDy) \
            $pgmOPTS(EndHr) $pgmOPTS(EndMn) $pgmOPTS(EndSc)
      FilePos $kO $defNo $pgmOPTS(BegYr) $pgmOPTS(BegDy) $pgmOPTS(BegHr) \
            $pgmOPTS(BegMn) $pgmOPTS(BegSc) COARSE

      lappend pgmOPTS(OPENED) ${kO},$defNo

      for { set J 3 } { $J < $LeN } { incr J } {
          set SeNs  [lindex $InFo $J]
          set nE [llength $SeNs]
          set S [lindex $SeNs 0] 
          lappend pgmOPTS(S.$iD) $S 
          set tU ""
          set tI ""
          for { set K 1 } { $K < $nE } { incr K 2 } {
             set U [lindex $SeNs $K] 
             set uiD [lindex $SeNs [expr $K + 1]]
             lappend tU [UTILunits $kO,0 $U $S]
             lappend tI $uiD
          }
          lappend pgmOPTS(U.$iD) $tU 
          lappend pgmOPTS(I.$iD) $tI 
      }

      if { [string match SI $iD] || [string match SE $iD] } { 
         set pgmOPTS(eV.$iD) [UTILunits $kO,0 20 0]
      }
   }
}
