package provide GEOplot 1.0

# THIS procedure does all the initializations that can be done just
#   before bringing up the User Interface

proc Inits { } {
   global pgmOPTS cFC

   set pgmOPTS(UCalled) 0
   set pgmOPTS(mapPROJ) ORTHOGRAPHIC
   set pgmOPTS(Base) 1
   set pgmOPTS(SIusesMo) 0
   set pgmOPTS(SEusesMo) 0

   if ![info exists pgmOPTS(CtBl)]      { set pgmOPTS(CtBl) ETones }
   if ![info exists pgmOPTS(cBFMin)]    { set pgmOPTS(cBFMin) 100.0 }
   if ![info exists pgmOPTS(cBFMax)]    { set pgmOPTS(cBFMax) 2000.0 }
   if ![info exists pgmOPTS(cBFSca)]    { set pgmOPTS(cBFSca) LOG }
   if ![info exists pgmOPTS(cenLNG)]    { set pgmOPTS(cenLNG) 0.0 }
   if ![info exists pgmOPTS(cenLAT)]    { set pgmOPTS(cenLAT) 40.0 }
   if ![info exists pgmOPTS(ScrBgnd)]   { set pgmOPTS(ScrBgnd) SWAP }
   if ![info exists pgmOPTS(minLAT)]    { set pgmOPTS(minLAT) FULL }
   if ![info exists pgmOPTS(GEOCoSyS)]  { set pgmOPTS(GEOCoSyS) MAGNETIC }
   if ![info exists pgmOPTS(DMSPsat)]   { set pgmOPTS(DMSPsat) DMSP-F13 }
   if ![info exists pgmOPTS(Parm1)]     { set pgmOPTS(Parm1) 0 }
   if ![info exists pgmOPTS(Parm2)]     { set pgmOPTS(Parm2) 0 }
   if ![info exists pgmOPTS(Parm3)]     { set pgmOPTS(Parm3) 0 }
   if ![info exists pgmOPTS(BegYr)]     { set pgmOPTS(BegYr) "" }
   if ![info exists pgmOPTS(BegDy)]     { set pgmOPTS(BegDy) "" }
   if ![info exists pgmOPTS(BegHr)]     { set pgmOPTS(BegHr) "" }
   if ![info exists pgmOPTS(BegMn)]     { set pgmOPTS(BegMn) "" }
   if ![info exists pgmOPTS(BegSc)]     { set pgmOPTS(BegSc) "" }
   if ![info exists pgmOPTS(EndYr)]     { set pgmOPTS(EndYr) "" }
   if ![info exists pgmOPTS(EndDy)]     { set pgmOPTS(EndDy) "" }
   if ![info exists pgmOPTS(EndHr)]     { set pgmOPTS(EndHr) "" }
   if ![info exists pgmOPTS(EndMn)]     { set pgmOPTS(EndMn) "" }
   if ![info exists pgmOPTS(EndSc)]     { set pgmOPTS(EndSc) "" }
   if ![info exists pgmOPTS(P0Min)]     { set pgmOPTS(P0Min) 100. }
   if ![info exists pgmOPTS(P1Min)]     { set pgmOPTS(P1Min) "" }
   if ![info exists pgmOPTS(P2Min)]     { set pgmOPTS(P2Min) "" }
   if ![info exists pgmOPTS(P3Min)]     { set pgmOPTS(P3Min) "" }
   if ![info exists pgmOPTS(P0Max)]     { set pgmOPTS(P0Max) 1200. }
   if ![info exists pgmOPTS(P1Max)]     { set pgmOPTS(P1Max) "" }
   if ![info exists pgmOPTS(P2Max)]     { set pgmOPTS(P2Max) "" }
   if ![info exists pgmOPTS(P3Max)]     { set pgmOPTS(P3Max) "" }
   if ![info exists pgmOPTS(P0Sca)]     { set pgmOPTS(P0Sca) LOG }
   if ![info exists pgmOPTS(P1Sca)]     { set pgmOPTS(P1Sca) LINEAR }
   if ![info exists pgmOPTS(P2Sca)]     { set pgmOPTS(P2Sca) LINEAR }
   if ![info exists pgmOPTS(P3Sca)]     { set pgmOPTS(P3Sca) LINEAR }
   if ![info exists pgmOPTS(P1Sync)]    { set pgmOPTS(P1Sync) NO }
   if ![info exists pgmOPTS(P2Sync)]    { set pgmOPTS(P2Sync) NO }
   if ![info exists pgmOPTS(P3Sync)]    { set pgmOPTS(P3Sync) NO }
   if ![info exists pgmOPTS(IonMin)]    { set pgmOPTS(IonMin) .1 }
   if ![info exists pgmOPTS(EleMin)]    { set pgmOPTS(EleMin) .1 }
   if ![info exists pgmOPTS(gSca)]      { set pgmOPTS(gSca) 1.0 }
   if ![info exists pgmOPTS(gSmo)]      { set pgmOPTS(gSmo) NO }



# THE fit the average energy to rayleigh transformation curve.  keV is the 
#   average energy in keV and CvF is the conversion.  The transformation is 
#   a 3 order polynomial on a log/log scale.

   set pgmOPTS(nC) 4

   set keV(0) 0.47   ; set CvF(0) 12770.0
   set keV(1) 2.0    ; set CvF(1) 9000.0
   set keV(2) 8.0    ; set CvF(2) 4770.0
   set keV(3) 25.0   ; set CvF(3) 2360.0
   set keV(4) 46.7   ; set CvF(4) 1630.0
                                                                                
   for { set I 0 } { $I < 5 } { incr I } {
      set lx($I) [expr log($keV($I))]
      set ly($I) [expr log($CvF($I))]
   }

   set cSM [ TUdataLSq1D lx ly 5 0 cFC icF $pgmOPTS(nC) CoV TUpolyFunc ]
}

