package provide GEOplot 1.0

# THIS procedure reads in the option file

proc LabelsUp { wN } {
   global GphInfo pgmOPTS

   set cW $GphInfo(White)
   set cL [list $GphInfo(Red) $GphInfo(Blue) $GphInfo(Green) $GphInfo(Purple)]
   set cC $GphInfo(Cyan)

# DISECT the FUV file name to get what info we can

   set iD [string range $pgmOPTS(FUVFILE) 0 2] 
   set yR [string range $pgmOPTS(FUVFILE) 3 6] 
   set dY [string range $pgmOPTS(FUVFILE) 7 9] 
   set hR [string range $pgmOPTS(FUVFILE) 10 11] 
   set mN [string range $pgmOPTS(FUVFILE) 12 13] 

   switch -exact -- $iD {
      s12 { set SrC SI-12 }
      s13 { set SrC SI-13 }
      wic { set SrC WIC   }
   }

   set GphInfo(curWin) $wN
   GPHwinScale $wN Xp Yp Zp 0
   set xT [GPHtextLen X XY]
   set xS [lindex $xT 0]
   set yS [lindex $xT 1]

   TextProp 12 HOLD HOLD

   set X $xS
   set iX [expr 4 * $xS]
   set Y [expr 1.0 - 2.0 * $yS]
   TexT $wN $X $Y 0.0 right "Image: FUV $SrC" $cW
   set Y [expr $Y - 1.5 * $yS]
   TexT $wN $X $Y 0.0 right "TIME: $yR $dY $hR:$mN" $cW
   set Y [expr $Y - 2.0 * $yS]
   TexT $wN $X $Y 0.0 right "DMSP: $pgmOPTS(DMSPsat)" $cW
   set Y [expr $Y - 1.5 * $yS]
   set yR [lindex $pgmOPTS(DMSPTm) 0]
   set dY [lindex $pgmOPTS(DMSPTm) 1]
   set mS [lindex $pgmOPTS(DMSPTm) 2]
   set Tm [TUtimeFmt 0 $yR $dY $mS]
   set hMs [split [lindex $Tm 2] ":"]
   set hR [lindex $hMs 0]
   set mN [lindex $hMs 1]
   set sS [lindex [split [lindex $hMs 2] "."] 0]
   set pgmOPTS(BseC) $sS
   TexT $wN $X $Y 0.0 right "TIME: $yR $dY ${hR}:${mN}:${sS}" $cW

   set Y [expr $Y - 2.0 * $yS]
   TexT $wN $X $Y 0.0 right "Trace 0: FUV Intensity" $GphInfo(Red)

   for { set I 1 } { $I <= 3 } { incr I } {
      set C [lindex $cL $I]
      set lC $C
      set P $pgmOPTS(Parm$I)
      if { $P > 0 } {
         set gL [UnitsLab $I 1]
         set Y [expr $Y - 2.0 * $yS]
         if { [string length [lindex $gL 2]] > 0 } { set C $cW }
         TexT $wN $X $Y 0.0 right "Trace $I: [lindex $gL 0]" $C
         if { [string length [lindex $gL 2]] > 0 } { 
            set Y [expr $Y - 1.5 * $yS]
            TexT $wN $iX $Y 0.0 right "[lindex $gL 2]" $lC
         }
         if { [string length [lindex $gL 3]] > 0 } { 
            set Y [expr $Y - 1.5 * $yS]
            TexT $wN $iX $Y 0.0 right "[lindex $gL 3]" $cC
         }
      }
   }
}
