package provide GEOplot 1.0

# THIS procedure reads in the option file

proc MapWinLimits { XLims YLims } {
   global pgmOPTS 

   upvar $XLims X 
   upvar $YLims Y 

   if [string match FULL $pgmOPTS(minLAT)] {
      set X(0) -1.0
      set X(1)  1.0
      set Y(0) -1.0
      set Y(1)  1.0
   } else {
      set iX(0) 0.0   ; set iY(0) $pgmOPTS(minLAT)
      set iX(1) 90.0  ; set iY(1) $pgmOPTS(minLAT)
      set iX(2) 180.0 ; set iY(2) $pgmOPTS(minLAT)
      set iX(3) -90.0 ; set iY(3) $pgmOPTS(minLAT)
                                                                                
      set MapOps [list $pgmOPTS(cenLNG) $pgmOPTS(cenLAT)]
      SetCorSys $pgmOPTS(mapPROJ) $MapOps
      GPHmapXY $pgmOPTS(mapPROJ) 4 iX iY oX oY S 0 $MapOps

      set Loc [TUdataMxMn oX 4 <>]
      if { $S([lindex $Loc 0]) != 1 } {
         set MinX -1.0
      } else { set MinX $oX([lindex $Loc 0]) }

      if { $S([lindex $Loc 0]) != 1 } {
         set MaxX 1.0
      } else { set MaxX $oX([lindex $Loc 1]) }

      set Loc [TUdataMxMn oY 4 <>]
      if { $S([lindex $Loc 0]) != 1 } {
         set MinY -1.0
      } else { set MinY $oY([lindex $Loc 0]) }
   
      if { $S([lindex $Loc 0]) != 1 } {
         set MaxY 1.0
      } else { set MaxY $oY([lindex $Loc 1]) }

      set dX [expr $MaxX - $MinX]
      set dY [expr $MaxY - $MinY]

      set Extra 0.0
      if { $dX > $dY } {
         set X(0) $MinX
         set X(1) $MaxX

         set dyH [expr ($dX - $dY) / 2.0]
         set TmP [expr $MaxY + $dyH]
         if { $TmP > 1.0 } {
            set Y(1) 1.0
            set Extra [expr $dyH - (1.0 - $MaxY)]
         } else { set Y(1) $TmP }

         set TmP [expr $MinY - $dyH - $Extra]
         if { $TmP < -1.0 } { set Y(0) -1.0 } else { set Y(0) $TmP }
      } else {
         set Y(0) $MinX
         set Y(1) $MaxX

         set dxH [expr ($dY - $dX) / 2.0]
         set TmP [expr $MaxX + $dxH]
         if { $TmP > 1.0 } {
            set X(1) 1.0
            set Extra [expr $dxH - (1.0 - $MaxX)]
         } else { set X(1) $TmP }

         set TmP [expr $MinX - $dxH - $Extra]
         if { $TmP < -1.0 } { set X(0) -1.0 } else { set X(0) $TmP }
      }
   }
   SetCorSys CARTESIAN [list 0.0 0.0]
}
