package provide GEOplot 1.0

# THIS procedure reads in the option file

proc MomDMSP { dfL dfH evL evH nP Species ReT { Ray 0 } } {
   global pgmOPTS 

   upvar $dfL fL
   upvar $dfH fH
   upvar $evL eL
   upvar $evH eH
   upvar $ReT rM

   set nE 0
   set BeG [expr $nP - 1] 
   for { set I $BeG } { $I >= 1 } { incr I -1 } {
      set dF($nE) $fL($I)
      set eV($nE) $eL($I)
      incr nE
   }

   set BeG [expr $nP - 1]
   for { set I $BeG } { $I >= 0 } { incr I -1 } {
      set dF($nE) $fH($I)
      set eV($nE) $eH($I)
      incr nE
   }

   if { $Species == "E" } { 
      set dCut $pgmOPTS(EleMin) 
      set Mass 9.11e-28
   } else { 
      set dCut $pgmOPTS(IonMin) 
      set Mass 1.67e-24
   } 

   Moments2D dF eV eV $nE $Mass CENTERS $dCut rM
}
