package provide GEOplot 1.0

# THIS procedure reads in the option file

proc OpenInfo { sNum } {
   global pgmOPTS 

   set SIsen "" ; set SIunit ""
   set SEsen "" ; set SEunit ""
   set SSIESsen "" ; set SSIESunit ""

   for { set I 1 } { $I <= 3 } { incr I } {
      switch -exact -- $pgmOPTS(Parm$I) {
         0   { set ReT "" }
         1   { lappend SIsen 0 ; lappend SIunit 12 }
         2   { lappend SIsen 1 ; lappend SIunit 12 }
         3   { lappend SIsen 0 1 ; lappend SIunit 12 12 }
         4   { lappend SIsen 0 1 ; lappend SIunit 16 16 }
         5   { lappend SEsen 0 ; lappend SEunit 12 }
         6   { lappend SEsen 1 ; lappend SEunit 12 }
         7   { lappend SEsen 0 1 ; lappend SEunit 12 12 }
         8   { lappend SEsen 0 1 ; lappend SEunit 16 16 }
         9   { lappend SSIESsen 5 ; lappend SSIESunit 2  }
         10  { lappend SSIESsen 4 ; lappend SSIESunit 2  }
         11  { lappend SSIESsen 3 ; lappend SSIESunit 1  }
         12  { lappend SSIESsen 0 1 2 ; lappend SSIESunit 0 0 0  }
         13  { lappend SIsen 0 1 ; lappend SIunit 16 16 }
         14  { lappend SIsen 0 1 ; lappend SIunit 16 16 }
         15  { lappend SEsen 0 1 ; lappend SEunit 16 16 }
         16  { lappend SEsen 0 1 ; lappend SEunit 16 16 }
         20  { lappend SIsen 0 1 0 1 ; lappend SIunit 16 16 12 12 }
      }
   }

   set ToT 0

   set nE [llength $SIsen]
   incr ToT $nE 
   set S(0) "" ; set U(0) "" ; set S(1) "" ; set U(1) ""
   for { set I 0 } { $I < $nE } { incr I } {
      set Sen  [lindex $SIsen $I ]
      set Unit [lindex $SIunit $I ]
      set S($Sen) $Sen
      if { $Unit == 12 } { set uID EF } else { set uID DF }
      if { [lsearch -exact $U($Sen) $Unit] < 0 } { lappend U($Sen) $Unit $uID } 
   }

   set SI [list SSJ4 SSJ4 ${sNum}SI]
   for { set I 0 } { $I < 2 } { incr I } {
      if { [string length $S($I)] > 0 } { 
         set Add [list $S($I)]
         set LeN [llength $U($I)]
         for { set K 0 } { $K < $LeN } { incr K } { 
             lappend Add [lindex $U($I) $K]
         }
         lappend SI $Add
      }
   }

   set nE [llength $SEsen]
   incr ToT $nE 
   set S(0) "" ; set U(0) "" ; set S(1) "" ; set U(1) ""
   for { set I 0 } { $I < $nE } { incr I } {
      set Sen  [lindex $SEsen $I ]
      set Unit [lindex $SEunit $I ]
      set S($Sen) $Sen
      if { $Unit == 12 } { set uID EF } else { set uID DF }
      if { [lsearch -exact $U($Sen) $Unit] < 0 } { lappend U($Sen) $Unit $uID } 
   }

   set SE [list SSJ4 SSJ4 ${sNum}SE]
   for { set I 0 } { $I < 2 } { incr I } {
      if { [string length $S($I)] > 0 } { 
         set Add [list $S($I)]
         set LeN [llength $U($I)]
         for { set K 0 } { $K < $LeN } { incr K } { 
             lappend Add [lindex $U($I) $K]
         }
         lappend SE $Add
      }
   }

   for { set I 0 } { $I < 6 } { incr I } {
      set S($I) "" ; set U($I) ""
   }

   set nE [llength $SSIESsen]
   incr ToT $nE 
   for { set I 0 } { $I < $nE } { incr I } {
      set Sen  [lindex $SSIESsen $I ]
      set Unit [lindex $SSIESunit $I ]
      set S($Sen) $Sen
      set U($Sen) $Unit
   }

   set UiDs [list Vx Vy Vz Dn Ti Te]
   set SSIES [list SSIES SSIES F${sNum}SSIES]
   for { set I 0 } { $I < 6 } { incr I } {
      if { [string length $S($I)] > 0 } { 
         lappend SSIES  "$I $U($I) [lindex $UiDs $S($I)]"
      }
   }

   if { $ToT == 0 } {
      set OA [list OA OA ${sNum}OC]
   } else { 
      if [string match MAGNETIC $pgmOPTS(GEOCoSyS)] {
          set OA [list OA OA ${sNum}OC "5 3" "3 0"] 
      } else { set OA [list OA OA ${sNum}OC "1 1" "0 0"] }
   }

   return [list $ToT $OA $SI $SE $SSIES]
}
