package provide GEOplot 1.0

proc OrbitTrack { nS } {
   global OALong OALat pgmOPTS GphInfo
   
   set wN 0
   set bS   [TUdataNoOctal $pgmOPTS(BseC)]
   set dTm  [expr 60.0 - $bS]
   set bP   [expr int((1000.0 * $dTm) / $pgmOPTS(dOA)) ]
   set SkiP [expr int(60000.0 / $pgmOPTS(dOA))]

   WinClip 0 1

   TextProp 4 HOLD HOLD

   set OpS [list $pgmOPTS(cenLNG) $pgmOPTS(cenLAT) 0.0]
   GPHmapXY $pgmOPTS(mapPROJ) $nS OALong OALat X Y S 0 $OpS

   MapWinLimits wX wY
   if { $pgmOPTS(nPlots) == 2 } {
      set R [expr abs($wX(1) - $wX(0))/100.0]
   } else { set R [expr abs($wX(1) - $wX(0))/150.0] }

   PlotColor HOLD $GphInfo(Red) $GphInfo(Red)
   Arc  $wN $X(0) $Y(0) 0.0 $R 0.0 360.0 1 0 -1

   for { set J $bP  } { $J < $nS } { incr J $SkiP } {
      if { $S($J) == 1 } {
         TexT $wN $X($J) $Y($J) 0.0 center + $GphInfo(White)
      }
   }
   update

   WinClip 0 0
}
