package provide GEOplot 1.0

# THIS procedure reads in the option file

proc PlotBoxes { } {
   global pgmOPTS GphInfo

   PLTinfoChg 1 ALL NUMBERS NSIZE 12
   PLTinfoChg 1 ALL NUMBERS TSIZE 12
   PLTinfoChg 1 Yb NUMBERS TCOLOR $GphInfo(Red)
   PLTinfoChg 1 Yt NUMBERS TCOLOR $GphInfo(Blue)
   if [string match LINEAR $pgmOPTS(P0Sca)] {
      if { $pgmOPTS(Parm1) == 0 } { set aX Y } else { set aX ub } 
      PLTinfoChg 1 $aX TICKS MJNUMBER 5
   }
   if { ($pgmOPTS(Parm1) > 0) && [string match LINEAR $pgmOPTS(P1Sca)] } {
      PLTinfoChg 1 Yt TICKS MJNUMBER 5
      if { $pgmOPTS(P1Max) >= 1.0e4 } {
         PLTinfoChg 1 Yt NUMBERS NFORMAT %.1e
      }
   }
   set dLabA "FUV INTEN"
   set uLabA "Rayleighs"
   set LbS [UnitsLab 1]
   set dLabB [lindex $LbS 0]
   set uLabB [lindex $LbS 1]
   if { $pgmOPTS(Parm1) == 0 } { set nLab BOT } else { set nLab BOTH } 
   if { $pgmOPTS(nPlots) == 1 } {
      set nOps [list BOT $nLab BOTH BOTH]
      set tOps [list "TIME UT" 0.5 $dLabA 1.0 "" 1.0 $dLabB 1.0]
   } else {
      set nOps [list NONE $nLab BOTH BOTH]
      set tOps [list "" 0.5 $dLabA 1.0 "" 1.0 $dLabB 1.0]
   }

   PlotOutlines 1 $tOps $nOps
   WinClip 1 0
   PLTaxisRec 1 Xt NONE AXIS 0.6 MINIMUM center $uLabA
   PLTaxisRec 1 Xt NONE AXIS 0.6 MAXIMUM center $uLabB

   if { $pgmOPTS(nPlots) == 2 } {
      PLTinfoChg 2 ALL NUMBERS NSIZE 12
      PLTinfoChg 2 ALL NUMBERS TSIZE 12
      PLTinfoChg 2 Yb NUMBERS TCOLOR $GphInfo(Green)
      PLTinfoChg 2 Yt NUMBERS TCOLOR $GphInfo(Purple)
      if { ($pgmOPTS(Parm2) > 0) && [string match LINEAR $pgmOPTS(P2Sca)] } {
         if { $pgmOPTS(Parm3) == 0 } { set aX Y } else { set aX yb } 
         PLTinfoChg 2 $aX TICKS MJNUMBER 5
         if { $pgmOPTS(P2Max) >= 1.0e4 } {
            PLTinfoChg 2 Yb NUMBERS NFORMAT %.1e
         }
      }
      if { ($pgmOPTS(Parm3) > 0) && [string match LINEAR $pgmOPTS(P3Sca)] } {
         PLTinfoChg 2 Yt TICKS MJNUMBER 5
         if { $pgmOPTS(P3Max) >= 1.0e4 } {
            PLTinfoChg 2 Yt NUMBERS NFORMAT %.1e
         }
      }
      set LbS [UnitsLab 2]
      set dLabA [lindex $LbS 0]
      set uLabA [lindex $LbS 1]
      set LbS [UnitsLab 3]
      set dLabB [lindex $LbS 0]
      set uLabB [lindex $LbS 1]
      if { $pgmOPTS(Parm3) == 0 } { 
          set nLab BOT 
      } elseif { $pgmOPTS(Parm2) == 0 } { 
          set nLab TOP 
      } else { set nLab BOTH } 
      set nOps [list BOT $nLab BOTH BOTH]
      set tOps [list "TIME UT" 0.5 $dLabA 1.0 "" 1.0 $dLabB 1.0]

      PlotOutlines 2 $tOps $nOps
      WinClip 2 0
      PLTaxisRec 2 Xt NONE AXIS 0.6 MINIMUM center $uLabA
      PLTaxisRec 2 Xt NONE AXIS 0.6 MAXIMUM center $uLabB
   }
}
