package provide GEOplot 1.0

# THIS procedure reads in the option file

proc ReadOA { UDFno } {
   global pgmOPTS ExDa RtoD OATm OALong OALat

# CHECK if we even need to read this data set

   set KeY   $pgmOPTS(K.OA)
   if { [string length $KeY] == 0 } { return 0 } 
  
# ESTABLISH a beginning and ending over which to get the data.

   set BegT $pgmOPTS(BegT)
   set EndT $pgmOPTS(EndT)
   set eY   $pgmOPTS(EndYr)
   set eD   $pgmOPTS(EndDy)

   set Ver 0
   set N 0

# GET the data

   set S(0) [lindex $pgmOPTS(S.OA) 0]
   set S(1) [lindex $pgmOPTS(S.OA) 1]
   set U(0) [lindex $pgmOPTS(U.OA) 0]
   set U(1) [lindex $pgmOPTS(U.OA) 1]

   set nE 0
   set More -1
   set EnD 1
   while { $More < 0 } {
      for { set J 0 } { $J <= $EnD } { incr J } {
         if { $J == $EnD } { set FwD 1 } else { set FwD 0 }
         set EoF [ReadUDF $KeY $UDFno $N $S($J) 0 $FwD 0]
         set oD($J) [ConvertToUnits $KeY $Ver $N $U($J) Data SENSOR]
      }
      set yB $ExDa($N,BYR)
      set dB $ExDa($N,BDY)
      set mB $ExDa($N,BMSEC)
      set yE $ExDa($N,EYR)
      set dE $ExDa($N,EDY)
      set mE $ExDa($N,EMSEC)
      set curT [list $yB $dB $mB 0]
      if [string match EOF $EoF] { break }

      if { $nE == 0 } { set pgmOPTS(baseT) [list $yB $dB $mB 0] ; set mSA $mB  }
      if { $nE == 1 } { set pgmOPTS(dOA) [expr $mB - $mSA] }
      set OALong($nE) $oD(0)
      set OALat($nE)  $oD(1)
      set OATm($nE) [TUtimeConv $pgmOPTS(baseT) $curT 0 pgmOPTS(Base)]
      incr nE

      set More [TUtimeCmp 0 $yE $dE $mE $eY $eD $EndT]
   }

   return $nE
}
