package provide GEOplot 1.0

# THIS procedure reads in the option file

proc ReadSSIES { UDFno X Ya Yb Yc Yd } {
   global ExDa pgmOPTS gOA

   upvar $X   pX
   upvar $Ya  Ti
   upvar $Yb  Te
   upvar $Yc  De
   upvar $Yd  Dr

# CHECK if we even need to read this data set
                                                                                
   set KeY   $pgmOPTS(K.SSIES)
   if { [string length $KeY] == 0 } { return 0 }

# ESTABLISH a beginning and ending time over which to get the data

   set BegT $pgmOPTS(BegT)
   set EndT $pgmOPTS(EndT)
   set eY   $pgmOPTS(EndYr)
   set eD   $pgmOPTS(EndDy)

# Establish the sensors and units to get

   set nS [expr [llength $pgmOPTS(S.SSIES)] - 1]
   for { set I 0 } { $I <= $nS } { incr I } {
      set S($I)  [lindex $pgmOPTS(S.SSIES) $I]
      set U($I)  [lindex $pgmOPTS(U.SSIES) $I]
      set iD($I) [lindex $pgmOPTS(I.SSIES) $I]
   }
  
   set Ver $UDFno

# GET the data

   set N 0
   set More -1
   while { $More < 0 } {
      for {set J 0 } { $J <= $nS } { incr J } {
         if { $J == $nS } { set FwD 1 } else { set FwD 0 }
         set EoF [ReadUDF $KeY $UDFno 0 $S($J) 0 $FwD 0]
         set D$iD($J) [ConvertToUnits $KeY $Ver 0 $U($J) Data SENSOR]
      }     

      set yB $ExDa(0,BYR)
      set dB $ExDa(0,BDY)
      set mB $ExDa(0,BMSEC)
      set yE $ExDa(0,EYR)
      set dE $ExDa(0,EDY)
      set mE $ExDa(0,EMSEC)
      set curT [list $yB $dB $mB 0]
      if [string match EOF $EoF] { break }
      if { $N == 0 } { set pgmOPTS(DMSPTm) $curT }

      set Tm [TUtimeConv $pgmOPTS(baseT) $curT 0 pgmOPTS(Base)]
      TUgridInfo 0 gOA gRET $Tm 0.0

      set More [TUtimeCmp 0 $yE $dE $mE $eY $eD $EndT]
      if { $gRET(0) < 0 } { continue }

      set pX($N) $Tm
      set nP [llength $pgmOPTS(SSIESdP)]
      set nD $ExDa(0,NSMP)
      for { set I 0 } { $I < $nP } { incr I } {
         switch -exact -- [lindex $pgmOPTS(SSIESdP) $I] {
            0 { set Te($N) $DTe }
            1 { set Ti($N) $DTi }
            2 { set De($N) $DDn }
            3 { set Dr($N) $DVy } 
         } 
      }
      incr N
      set More [TUtimeCmp 0 $yE $dE $mE $eY $eD $EndT]
   }

   return $N
}
