package provide GEOplot 1.0

# THIS procedure reads in the option file

proc RunIt { } {
   global pgmOPTS GphInfo SIeV0 SIeV1

   SetUp
   set nO [BegDMSP 0]

   set nOA [ReadOA 0]
   ProcessOA $nOA

   set nSI [ReadSI 0 sIX sIEFL sIEFH sID sIT sIaE sISIM]
   set nSE [ReadSE 0 sEX sEEFL sIEFH sED sET sEaE]
   set nSS [ReadSSIES 0 sSX sSTe sSTi sSDen sSVdr]

   GraphicsUp
   ColorUp
   LabelsUp A
   update

   PlotGEO
   OrbitTrack $nOA
   PlotGEOCut $nOA

   set AxiS [list Yb Yt Yb Yt]
   set cLr [list $GphInfo(Red) $GphInfo(Blue) $GphInfo(Green) $GphInfo(Purple)] 
   set cC $GphInfo(Cyan)
   for { set I 1 } { $I <= 3 } { incr I } {
       set P $pgmOPTS(Parm$I)
       set SynC $pgmOPTS(P${I}Sync)
       set aX [lindex $AxiS $I] 
       set C  [lindex $cLr $I]
       set wN [expr int($I / 2) + 1]
       switch -exact -- $P {
          1 {  PlotParm $wN $aX $nSI sIX sIEFH [list $C < 1.0e-9] $SynC }
          2 {  PlotParm $wN $aX $nSI sIX sIEFL [list $C < 1.0e-9] $SynC }
          3 {  PlotParm $wN $aX $nSI sIX sIEFH [list $C < 1.0e-9] $SynC 
               PlotParm $wN $aX $nSI sIX sIEFL [list $cC < 1.0e-9] $SynC 
            }
          4 {  PlotParm $wN $aX $nSI sIX sIaE [list $C < 1.0e-9] $SynC }
          5 {  PlotParm $wN $aX $nSE sEX sEEFH [list $C < 1.0e-9] $SynC }
          6 {  PlotParm $wN $aX $nSE sEX sEEFL [list $C < 1.0e-9] $SynC }
          7 {  PlotParm $wN $aX $nSE sEX sEEFH [list $C < 1.0e-9] $SynC 
               PlotParm $wN $aX $nSE sEX sEEFL [list $cC < 1.0e-9] $SynC 
            }
          8 {  PlotParm $wN $aX $nSE sEX sEaE [list $C < 1.0e-9] $SynC }
          9 {  PlotParm $wN $aX $nSS sSX sSTe [list $C < 1.0e-9] $SynC }
         10 {  PlotParm $wN $aX $nSS sSX sSTi [list $C < 1.0e-9] $SynC }
         11 {  PlotParm $wN $aX $nSS sSX sSDen [list $C < 1.0e-9] $SynC }
         12 {  PlotParm $wN $aX $nSS sSX sSVdr [list $C < -4.0e3] $SynC }
         13 {  PlotParm $wN $aX $nSI sIX sID [list $C < -4.0e3] $SynC }
         14 {  PlotParm $wN $aX $nSI sIX sIT [list $C < -4.0e3] $SynC }
         15 {  PlotParm $wN $aX $nSE sEX sED [list $C < -4.0e3] $SynC }
         16 {  PlotParm $wN $aX $nSE sEX sET [list $C < -4.0e3] $SynC }
         20 {  PlotParm $wN $aX $nSI sIX sISIM [list $C < 0.1] $SynC }
       }
   }

   PlotBoxes

   SetCorSys CARTESIAN [list 0.0 ]
}
