package provide GEOplot 1.0

# THIS procedure reads in the option file

proc SetUp { } {
   global pgmOPTS 

   if [info exists pgmOPTS(OPENED)] {
      set nO [llength pgmOPTS(OPENED)]
      for { set I 0 } { $I < $nO } { incr I } {
         set kV [lindex $pgmOPTS(OPENED) $I]
         set KeY [lindex [split $kV ","] 0]
         set Ver [lindex [split $kV ","] 1]
         CloseUDF $KeY $Ver
      }
   }

   set pgmOPTS(OPENED) ""

   if [winfo exists .pLoT0] {
       destroy .pLoT0
       set GphInfo(CurScr) 0
       update
   }
   if [info exists WinInfo(50,Dimen)] { CloseWindow 50 }

   if [string match FULL $pgmOPTS(minLAT)] {
      set pgmOPTS(gID) FULL
   } elseif { $pgmOPTS(minLAT) >= 0.0 } {
      set pgmOPTS(gID) NORTH
   } else { set pgmOPTS(gID) SOUTH }

   set pgmOPTS(SIdP) ""
   set pgmOPTS(SEdP) ""
   set pgmOPTS(SSIESdP) ""
   set pgmOPTS(SIusesMo) 0
   set pgmOPTS(SEusesMo) 0

   for { set I 1 } { $I <= 3 } { incr I } { 
      if { $pgmOPTS(Parm$I) == 0 } { continue }
      switch -exact -- $pgmOPTS(Parm$I) {
         1   { set oP 0 ; set iD SIdP }
         2   { set oP 1 ; set iD SIdP }
         3   { set oP [list 0 1] ; set iD [list SIdP SIdP] }
         4   { set oP 2 ; set iD SIdP ; set pgmOPTS(SIusesMo) 1}
         5   { set oP 0 ; set iD SEdP }
         6   { set oP 1 ; set iD SEdP }
         7   { set oP [list 0 1] ; set iD [list SEdP SEdP] }
         8   { set oP 2 ; set iD SEdP ; set pgmOPTS(SEusesMo) 1 }
         9   { set oP 0 ; set iD SSIESdP }
         10  { set oP 1 ; set iD SSIESdP }
         11  { set oP 2 ; set iD SSIESdP }
         12  { set oP 3 ; set iD SSIESdP }
         13  { set oP 4 ; set iD SIdP ; set pgmOPTS(SIusesMo) 1 }
         14  { set oP 5 ; set iD SIdP ; set pgmOPTS(SIusesMo) 1 }
         15  { set oP 4 ; set iD SEdP ; set pgmOPTS(SEusesMo) 1 }
         16  { set oP 5 ; set iD SEdP ; set pgmOPTS(SEusesMo) 1 }
         20  { set oP 3 ; set iD SIdP ; set pgmOPTS(SIusesMo) 1 }
      }
      set nE [llength $oP]
      for { set J 0 } { $J < $nE } { incr J } {
         set X [lindex $iD $J]
         set Y [lindex $oP $J]
         if { [lsearch -exact $pgmOPTS($X) $Y] < 0 } { 
            lappend pgmOPTS($X) $Y
         }
      }
   }

   if { ($pgmOPTS(Parm2) > 0) || ($pgmOPTS(Parm3) > 0) } {
      set pgmOPTS(nPlots) 2
   } else { set pgmOPTS(nPlots) 1 }
}
