package provide GEOplot 1.0

# THIS procedure reads in the option file

proc SimConv {  } {
   global pgmOPTS SIeV0 SIeV1 SimCF0 SimCF1 cFC

   for { set I 0 } { $I < $pgmOPTS(nSI)} { incr I } {
      set E0 [expr $SIeV0($I) / 1000.0]
      set E1 [expr $SIeV1($I) / 1000.0]
      set lE0 [expr log($E0)]
      set lE1 [expr log($E1)]
      if { $E0 > .45 } {
         set SimCF0($I) [expr exp([TUpolyExp1D $lE0 $pgmOPTS(nC) cFC])]
      } else { set SimCF0($I) 0.0 }
      if { $E1 > .45 } {
         set SimCF1($I) [expr exp([TUpolyExp1D $lE1 $pgmOPTS(nC) cFC])]
      } else { set SimCF1($I) 0.0 }
   }

   set nE 0
   set BeG [expr $pgmOPTS(nSI) - 1]
   for { set I $BeG } { $I >= 1 } { incr I -1 } {
      set X($nE) [expr $SIeV1($I) / 1000.0]
      set Y($nE) $SimCF1($I)
      incr nE
   }

   set BeG [expr $pgmOPTS(nSI) - 1]
   for { set I $BeG } { $I >= 0 } { incr I -1 } {
      set X($nE) [expr $SIeV0($I) / 1000.0]
      set Y($nE) $SimCF0($I)
      incr nE
   }

   set V 0.0

   for { set I 0 ; set J 1 } { $J < $nE } { incr I ; incr J } {
      set dX  [expr $X($J) - $X($I)]
      set dY  [expr $Y($J) - $Y($I)]
      set V [expr $V +  $dX * $Y($I) + .5 * $dX * $dY]
   }

   set pgmOPTS(sNorm) $V
}
