package provide GEOplot 1.0

# THIS procedure reads in the option file

proc UnitsLab { DeF { Trace 0 } } {
   global pgmOPTS SIeV0 SIeV1 SEeV0 SEeV1

   if !$Trace {
      switch -exact -- $pgmOPTS(Parm$DeF) {
         0   { set dLab "" ; set uLab "" }
         1   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         2   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         3   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         4   { set dLab "AVG E" ; set uLab eV }
         5   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         6   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         7   { set dLab "TOT EFLUX" ; set uLab "erg/cm^2-s"}
         8   { set dLab "AVG E" ; set uLab eV }
         9   { set dLab Te ; set uLab "deg K" }
         10  { set dLab Ti ; set uLab "deg K" }
         11  { set dLab Den ; set uLab "/cm^3" }
         12  { set dLab Vy ; set uLab "m/s" }
         13  { set dLab Den ; set uLab "/cm^3" }
         14  { set dLab Temp ; set uLab "eV" }
         15  { set dLab Den ; set uLab "/cm^3" }
         16  { set dLab Temp ; set uLab "eV" }
         20  { set dLab "SIM INTEN" ; set uLab "Rayleighs" }
      }
      set ReT [list $dLab $uLab]
   } else {
      set eLab1 "" 
      set eLav2 ""
      switch -exact -- $pgmOPTS(Parm$DeF) {
         0   {  set dLab "" ; uLab "" }
         1   {  set dLab "SSJ4 Ion EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SIeV0([expr $pgmOPTS(nSI) - 1])
                set eVB $SIeV0(0)
                set eLab1 [format "%.1f - %.1f" $eVA $eVB]
             }
         2   {  set dLab "SSJ4 Ion EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SIeV1([expr $pgmOPTS(nSI) - 1])
                set eVB $SIeV1(0)
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
         }
         3   {  set dLab "SSJ4 Ion EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SIeV0([expr $pgmOPTS(nSI) - 1])
                set eVB $SIeV0(0)
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
                set eVA $SIeV1([expr $pgmOPTS(nSI) - 1])
                set eVB $SIeV1(0)
                set eLab2 [format "%.1f - %.1f eV" $eVA $eVB]
         }
         4   {  set dLab "SSJ4 Ion <E>"   
                set uLab eV 
                set eVB $SIeV0(0)
                set eVA $SIeV1([expr $pgmOPTS(nSI) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         5   {  set dLab "SSJ4 e- EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SEeV0([expr $pgmOPTS(nSE) - 1])
                set eVB $SEeV0(0)
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         6   {  set dLab "SSJ4 e- EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SEeV1([expr $pgmOPTS(nSE) - 1])
                set eVB $SEeV1(0)
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
         }
         7   {  set dLab "SSJ4 e- EFLUX" 
                set uLab "erg/cm^2-s"
                set eVA $SEeV0([expr $pgmOPTS(nSE) - 1])
                set eVB $SEeV0(0)
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
                set eVA $SEeV1([expr $pgmOPTS(nSE) - 1])
                set eVB $SEeV1(0)
                set eLab2 [format "%.1f - %.1f eV" $eVA $eVB]
         }
         8   {  set dLab "SSJ4 e- <E>"   
                set uLab eV 
                set eVB $SEeV0(0)
                set eVA $SEeV1([expr $pgmOPTS(nSI) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         9   {  set dLab "SSIES Te" ; set uLab "deg K" }
         10  {  set dLab "SSIES Ti" ; set uLab "deg K" }
         11  {  set dLab "SSIES Den" ; set uLab "/cm^3" }
         12  {  set dLab "SSIES Cross Track Drift" ; set uLab "/cm^3" }
         13  {  set dLab "SSJ4 Ion Density"   
                set uLab "/cm^3" 
                set eVB $SIeV0(0)
                set eVA $SIeV1([expr $pgmOPTS(nSI) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         14  {  set dLab "SSJ4 Ion Temp"   
                set uLab "eV" 
                set eVB $SIeV0(0)
                set eVA $SIeV1([expr $pgmOPTS(nSI) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         15  {  set dLab "SSJ4 e- Density"   
                set uLab "/cm^3" 
                set eVB $SEeV0(0)
                set eVA $SEeV1([expr $pgmOPTS(nSE) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         16  {  set dLab "SSJ4 e- Temp"   
                set uLab "eV" 
                set eVB $SEeV0(0)
                set eVA $SEeV1([expr $pgmOPTS(nSE) - 1])
                set eLab1 [format "%.1f - %.1f eV" $eVA $eVB]
             }
         20  {  set dLab "Sim Rayleighs" ; set uLab "Rayleighs" }
      }
      set ReT [list $dLab $uLab $eLab1 $eLav2]
   }

   return $ReT
}
