package provide GEOplot 1.0

# THIS puts the User Interface

proc UserInterface { } {
   global pgmOPTS GphInfo env

# READ in the preference file
                                                                                
   GUIprefsRead

# LAY out the window names for the GUI frame structure
                                                                                
   set Wa  .fopCTRL
   set Wb  .fopOPTS

   set ScOps [list LINEAR|0 LOG|1]
   set YnOps [list NO|0 YES|1]
   set CsOps [list MAGNETIC|0 GEOGRAPHIC|1]
   set StOps [list DMSP-F12 DMSP-F13 DMSP-F14 DMSP-F15]
   set MsOps [list NONE|0 \
                   "Total Ion Energy Flux (1-35 keV)|1" \
                   "Total Ion Energy Flux (30-1000 eV)|2" \
                   "Total Ion Energy Flux (both ranges)|3" \
                   "Energetic Ion Density (/cc)|13" \
                   "Energetic Ion Temperature (ev)|14" \
                   "Energetic Ion Average Energy (ev)|4" \
                   "Total e- Energy Flux (1-35 keV)|5" \
                   "Total e- Energy Flux (30-1000 eV)|6" \
                   "Total e- Energy Flux (both ranges)|7" \
                   "Energetic e- Density (/cc)|15" \
                   "Energetic e- Temperature (ev)|16" \
                   "Energetic e- Average Energy (ev)|8" \
                   "Ambient Density (/cc)|11" \
                   "Ambient e- Temperature (degK)|9" \
                   "Ambient Ion Temperature (degK)|10" \
                   "Ambient Cross Track Ion Drift (m/s)|12" \
                   "SI-12 Simulated Emission|20" ]
   set SyOps [list NO|0 SUM|1 AVERAGE|2]
   set SrOps [list "WHITE BACKGROUND|SWAP" "BLACK BACKGROUND|NOWSWAP"]
                                                                           
   if { [winfo exists .fopCTRL] == 0 } {
      wm title . "GME PLOTS"
                                                                                
      GUIFrame $Wa -1 pack|top||x
      GUIFrame $Wb -1 pack|top||x

      GUIbuttonPush $Wa.quit Quit pack|right "exit" 6
      GUIbuttonPush $Wa.run Run   pack|left   "RunIt" 6
      
      set CtOps [GUctblOpts]
      if ![info exists pgmOPTS(CtBl)] {
         set pgmOPTS(CtBl) [lindex [split [lindex $CtOps 0] '|'] 1 ]
         set CtLab [lindex [split [lindex $CtOps 0] '|'] 0 ]
      } else {
         set CtLab ""
         set nCt [llength $CtOps]
         for { set I 0 } { $I < $nCt } { incr I } {
            set AlT [lindex [split [lindex $CtOps $I] '|'] 1 ]
            if {[string compare $AlT $pgmOPTS(CtBl)] == 0 } {
               set CtLab [lindex [split [lindex $CtOps $I] '|'] 0 ]
               break
            }
         }
         if { [string length $CtLab] == 0 } {
            set pgmOPTS(CtBl) [lindex [split [lindex $CtOps 0] '|'] 1 ]
            set CtLab [lindex [split [lindex $CtOps 0] '|'] 0 ]
         } 
      }

      set Row 0

      GUILabel $Wb.rdlab "Read Menu"  w grid|$Row|0|w
      GUIboxEntry $Wb.read  grid|$Row|1|w||6 27 pgmOPTS(OptFile)
      GUIbuttonPush $Wb.readb Read grid|$Row|7|w| "ReadOpts" 6

      incr Row 
      GUILabel $Wb.svlab "Save Menu"  w grid|$Row|0|w
      GUIboxEntry $Wb.save  grid|$Row|1|w||6 27 pgmOPTS(saveM)
      GUIbuttonPush $Wb.saveb Save grid|$Row|7|w| "SaveOpts" 6

      incr Row 
      GUILabel $Wb.ctlab "Color Scheme"  w grid|$Row|0|w
      GUIbuttonMenu $Wb.ct $CtLab grid|$Row|1|ew||4 $CtOps  \
           "GUIoptsProcess .fopOPTS.ct pgmOPTS(CtBl) ALT " 6
      if [string match SWAP $pgmOPTS(ScrBgnd)] {
         set LaB "WHITE BACKGROUND"
      } else { set LaB "BLACK BACKGROUND" }
      GUIbuttonToggle $Wb.scrc $LaB grid|$Row|5|e||3 \
              $SrOps "GUIoptsToggle $Wb.scrc pgmOPTS(ScrBgnd) ALT " 6

      incr Row 
      GUILabel $Wb.gslab "Mesh Scale / Fill"  w grid|$Row|0|w
      GUIboxEntry $Wb.gs  grid|$Row|1|||1 9 pgmOPTS(gSca)
      GUIbuttonToggle $Wb.smo $pgmOPTS(gSmo) grid|$Row|3|ew \
              $YnOps "GUIoptsToggle $Wb.smo pgmOPTS(gSmo) PRI " 6

      incr Row 
      GUILabel $Wb.hctlab "FUV Image Color Scale"  w grid|$Row|0|w
      GUIboxEntry $Wb.hmin  grid|$Row|1|||2 9 pgmOPTS(cBFMin)
      GUIboxEntry $Wb.hmax  grid|$Row|3|||3 9 pgmOPTS(cBFMax)
      GUIbuttonToggle $Wb.hsca $pgmOPTS(cBFSca) grid|$Row|6|ew \
              $ScOps "GUIoptsToggle $Wb.hsca pgmOPTS(cBFSca) PRI " 6

      incr Row
      GUILabel $Wb.pfslab "FUV Lineplot Scaling"  w grid|$Row|0|w
      GUIboxEntry $Wb.pfmin  grid|$Row|1|||2 9 pgmOPTS(P0Min)
      GUIboxEntry $Wb.pfmax  grid|$Row|3|||3 9 pgmOPTS(P0Max)
      GUIbuttonToggle $Wb.pfsca $pgmOPTS(P0Sca) grid|$Row|6|ew \
              $ScOps "GUIoptsToggle $Wb.pfsca pgmOPTS(P0Sca) PRI " 6

      incr Row 
      GUILabel $Wb.clnglab "Center Long / Lat"  w grid|$Row|0|w
      GUIboxEntry $Wb.clng  grid|$Row|1|||2 9 pgmOPTS(cenLNG)
      GUIboxEntry $Wb.clat  grid|$Row|3|||2 9 pgmOPTS(cenLAT)

      incr Row 
      GUILabel $Wb.mlatlab "Minimum Latitude"  w grid|$Row|0|w
      GUIboxEntry $Wb.mlat  grid|$Row|1|||2 9 pgmOPTS(minLAT)

      incr Row 
      GUILabel $Wb.mhlab "FUV Image Dir"  w grid|$Row|0|w
      GUIboxEntry $Wb.mhome  grid|$Row|1|w||6 27 pgmOPTS(FUVHOME)

      incr Row 
      GUILabel $Wb.menalab "FUV Image File"  w grid|$Row|0|w
      GUIboxEntry $Wb.mena  grid|$Row|1|w||5 18 pgmOPTS(FUVFILE)

      incr Row 
      GUILabel $Wb.fcslab "FUV Coordinates"  w grid|$Row|0|w
      GUIbuttonToggle $Wb.fcs $pgmOPTS(GEOCoSyS) grid|$Row|1|ew||3 \
              $CsOps "GUIoptsToggle $Wb.fcs pgmOPTS(GEOCoSyS) PRI " 6

      incr Row
      GUILabel $Wb.sclab "DMSP Satellite"  w grid|$Row|0|w
      GUIbuttonMenu $Wb.sat $pgmOPTS(DMSPsat) grid|$Row|1|||2 $StOps  \
           "GUIoptsProcess $Wb.sat pgmOPTS(DMSPsat) PRI " 6

      incr Row
      GUILabel $Wb.btlab "Beg Time (YDHMS)"  w grid|$Row|0|w
      GUIboxEntry $Wb.byr  grid|$Row|1|w 5 pgmOPTS(BegYr)
      GUIboxEntry $Wb.bdy  grid|$Row|2|w 4 pgmOPTS(BegDy)
      GUIboxEntry $Wb.bhr  grid|$Row|3|w 3 pgmOPTS(BegHr)
      GUIboxEntry $Wb.bmn  grid|$Row|4|w 3 pgmOPTS(BegMn)
      GUIboxEntry $Wb.bsc  grid|$Row|5|w 3 pgmOPTS(BegSc)

      incr Row
      GUILabel $Wb.etlab "End Time (YDHMS)"  w grid|$Row|0|w
      GUIboxEntry $Wb.eyr  grid|$Row|1|w 5 pgmOPTS(EndYr)
      GUIboxEntry $Wb.edy  grid|$Row|2|w 4 pgmOPTS(EndDy)
      GUIboxEntry $Wb.ehr  grid|$Row|3|w 3 pgmOPTS(EndHr)
      GUIboxEntry $Wb.emn  grid|$Row|4|w 3 pgmOPTS(EndMn)
      GUIboxEntry $Wb.esc  grid|$Row|5|w 3 pgmOPTS(EndSc)

      incr Row

      set wID [list a a b c ]
      set C #FF0000
      set FonT [list "" 12 bold]
      for { set I 1 } { $I < 4 } { incr I } { 
         set iD [lindex $wID $I] 
         set LaB "Plot Parameter $I"
         GUILabel $Wb.pp${iD}lab $LaB w grid|$Row|0|w 0 0 "" $FonT
         set WiD $Wb.pp$iD
         GUIbuttonMenu $WiD "" grid|$Row|1|||8 $MsOps  \
              "GUIoptsProcess $WiD pgmOPTS(Parm$I) ALT " 6 -1 "" left
         set LaB [GUIoptsInfo $Wb.pp$iD OPTV $pgmOPTS(Parm$I) ALT PRI]
         $Wb.pp${iD} configure -text $LaB
         incr Row
         GUILabel $Wb.p${iD}slab "     Scaling"  w grid|$Row|0|w
         GUIboxEntry $Wb.p${iD}min  grid|$Row|1|||2 9 pgmOPTS(P${I}Min)
         GUIboxEntry $Wb.p${iD}max  grid|$Row|3|||3 9 pgmOPTS(P${I}Max)
         set WiD $Wb.pp${iD}sca
         GUIbuttonToggle $WiD $pgmOPTS(P${I}Sca) grid|$Row|6|ew \
                 $ScOps "GUIoptsToggle $WiD pgmOPTS(P${I}Sca) PRI " 6
         incr Row
         GUILabel $Wb.pp${iD}sylab "     Sync With FUV"  w grid|$Row|0|w
         set WiD $Wb.pp${iD}sync
         GUIbuttonMenu $WiD $pgmOPTS(P${I}Sync) grid|$Row|1|||2 $SyOps  \
              "GUIoptsProcess $WiD pgmOPTS(P${I}Sync) PRI " 6 -1 "" left
         incr Row
      }

      incr Row
      GUIblankRow $Wb $Row 1.0
                                                                                
      incr Row
      GUILabel $Wb.pdlab "Miscellaneous Definitions"  w grid|$Row|0|w

      incr Row
      GUIblankRow $Wb $Row 1.0

      incr Row
      GUILabel $Wb.midlab "Min Acceptable Ion Density"  w grid|$Row|0|w
      GUIboxEntry $Wb.mid  grid|$Row|1|||2 9 pgmOPTS(IonMin)

      incr Row
      GUILabel $Wb.medlab "Min Acceptable e- Density"  w grid|$Row|0|w
      GUIboxEntry $Wb.med  grid|$Row|1|||2 9 pgmOPTS(EleMin)
   }

   update
   bind  .fopOPTS.read <Return> { .fopOPTS.save delete 0 end ; \
                                  .fopOPTS.save insert end "$pgmOPTS(OptFile)"}
}
